--
-- liftableAxes
-- by Blacky_BPG
-- 
-- 
-- Version   1.4.4.0 F   23.09.2017     fix self motorized control, fix help window text if indoor control active, fix outdoor index error if outdoor = false
-- Version   1.4.4.0 E   21.09.2017     fix automatic lift for referencing axes if the reference axis is lift, added sound option
-- Version   1.4.4.0 D   18.09.2017     add reference axis and forceLift for complete lower/lift of vehicles
-- Version   1.4.4.0 C   14.09.2017     set animation stop time synchronisation for better look for clients, now wheels touch the ground in MP as in the SP
-- Version   1.4.4.0 B   04.08.2017     add default lock for "offline" use and add canBeUsedOffline variable for xml (not recommended)
-- Version   1.4.4.0 A   02.08.2017     fix autoCorrection function for dedicated servers
-- Version   1.4.4.0     06.07.2017     initial version for FS17
-- 

liftableAxes = {} function liftableAxes.prerequisitesPresent(specializations) return (SpecializationUtil.hasSpecialization(AnimatedVehicle, specializations) and SpecializationUtil.hasSpecialization(Cylindered, specializations)) end function liftableAxes:preLoad(savegame) self.getIsToggleLiftableAxisAllowed = liftableAxes.getIsToggleLiftableAxisAllowed self.setLiftableAxesState = liftableAxes.setLiftableAxesState self.getMotorizedAttacher = liftableAxes.getMotorizedAttacher end function liftableAxes:getMotorizedAttacher(laTrailer) if laTrailer ~= nil then if laTrailer.attacherVehicle ~= nil then if laTrailer.attacherVehicle.getIsMotorStarted ~= nil then if laTrailer.attacherVehicle:getIsMotorStarted() then return true else      return false end else     return liftableAxes:getMotorizedAttacher(laTrailer.attacherVehicle) end else    if laTrailer.getIsMotorStarted ~= nil and laTrailer:getIsMotorStarted() then return true else     return false end end end return false end function liftableAxes:load(savegame) self.liftableAxes = {} end function liftableAxes:postLoad(savegame) local animTime = nil local i=0 while true do if not hasXMLProperty(self.xmlFile, "vehicle.liftableAxes") then break end self.useOffline = Utils.getNoNil(getXMLBool(self.xmlFile, "vehicle.liftableAxes#canBeUsedOffline"), false) local key = string.format("vehicle.liftableAxes.liftableAxis(%d)", i) if not hasXMLProperty(self.xmlFile, key) then break end local axis = {} axis.animationName = getXMLString(self.xmlFile, key.."#animationName") axis.airSound = SoundUtil.loadSample(self.xmlFile, {}, key..".airSound", nil, self.baseDirectory, self.components[1].node) if axis.animationName ~= nil then axis.lowerText = Utils.getNoNil(getXMLString(self.xmlFile, key.."#lowerText"), "action_lowerOBJECT") axis.liftText = Utils.getNoNil(getXMLString(self.xmlFile, key.."#liftText"), "action_liftOBJECT") axis.airConsumption = Utils.getNoNil(getXMLFloat(self.xmlFile, key.."#airConsumption"), 1000) / self:getAnimationDuration(axis.animationName) local liftKey = getXMLString(self.xmlFile, key.."#liftKey") if liftKey ~= nil then axis.liftKey = InputBinding[liftKey] end axis.liftKey = Utils.getNoNil(axis.liftKey, InputBinding.LOWER_IMPLEMENT) axis.maxLoadForLift = Utils.getNoNil(getXMLFloat(self.xmlFile, key.."#maxLoadForLift"),0.5) axis.touchValue = Utils.getNoNil(getXMLInt(self.xmlFile, key.."#touchValue"),20) axis.referenceAxis = getXMLInt(self.xmlFile, key.."#referenceAxis") axis.forceLift = Utils.getNoNil(getXMLBool(self.xmlFile, key.."#forceLift"),false) axis.outdoor = Utils.getNoNil(getXMLBool(self.xmlFile, key.."#outdoor"),false) axis.noText = Utils.getNoNil(getXMLBool(self.xmlFile, key.."#noText"),false) if axis.outdoor then local idx = getXMLString(self.xmlFile, key.."#outdoorIndex") if idx ~= nil then axis.outdoorIndex = Utils.indexToObject(self.components,idx) end axis.outdoorAnimation = getXMLString(self.xmlFile, key.."#outdoorAnimation") end if axis.outdoor and axis.outdoorIndex == nil then axis.outdoor = false print("Error: Index for outdoor control for liftable axis "..tostring(i+1).." can not be found") printCallstack() end axis.indoor = not axis.outdoor axis.indoor = Utils.getNoNil(getXMLBool(self.xmlFile, key.."#indoor"),axis.indoor) axis.mustInit = false axis.isLowered = false local onStart = Utils.getNoNil(getXMLString(self.xmlFile, key.."#onStart"),"lift") if onStart == "lower" then axis.isLowered = true axis.mustInit = true end axis.numTouched = 0 axis.hasSteerableWheel = false axis.hasAutoCorrection = false axis.animTimeSend = true local x=0 axis.wheels = {} axis.refWheels = {} local wheelKey = string.format(key..".wheel(%d)", x) while hasXMLProperty(self.xmlFile, wheelKey) do local wheel = {} wheel.index = getXMLInt(self.xmlFile, wheelKey.."#index") wheel.autoCorrect = Utils.getNoNil(getXMLBool(self.xmlFile, wheelKey.."#autoCorrect"),false) if wheel.index ~= nil and self.wheels[wheel.index] ~= nil then if (not wheel.autoCorrect) and (self.wheels[wheel.index].steeringAxleRotMax ~= 0 or self.wheels[wheel.index].steeringAxleRotMin ~= 0) then wheel.stopSteering = Utils.getNoNil(getXMLBool(self.xmlFile, wheelKey.."#stopSteering"),true) if wheel.stopSteering then axis.hasSteerableWheel = true wheel.backupScale = self.wheels[wheel.index].steeringAxleScale end end if wheel.autoCorrect then if not axis.forceLift then axis.hasAutoCorrection = true table.insert(axis.refWheels, wheel) end else       table.insert(axis.wheels, wheel) end end x = x + 1 wheelKey = string.format(key..".wheel(%d)", x) end table.insert(self.liftableAxes, axis) end i = i + 1 end if table.getn(self.liftableAxes) > 0 then for i=1, table.getn(self.liftableAxes) do if self.liftableAxes[i].referenceAxis ~= nil then if self.liftableAxes[self.liftableAxes[i].referenceAxis] == nil then print("Error: Reference axis "..tostring(self.liftableAxes[i].referenceAxis).." for liftable axis "..tostring(i).." can not be found") self.liftableAxes[i].referenceAxis = nil end end local animTime = 0 if self.liftableAxes[i].isLowered then if self.liftableAxes[i].forceLift then animTime = self:getAnimationDuration(self.liftableAxes[i].animationName) end end if savegame ~= nil and not savegame.resetVehicles then self.liftableAxes[i].mustInit = true self:setLiftableAxesState(i,Utils.getNoNil(getXMLBool(savegame.xmlFile, savegame.key.."#axis"..tostring(i).."Lowered"),false)) animTime = Utils.getNoNil(getXMLFloat(savegame.xmlFile, savegame.key.."#axis"..tostring(i).."Time"),animTime) end self:setRealAnimationTime(self.liftableAxes[i].animationName,animTime) end end end function liftableAxes:getSaveAttributesAndNodes(nodeIdent) if table.getn(self.liftableAxes) > 0 then local attributes = '' for i=1, table.getn(self.liftableAxes) do attributes = attributes..' axis'..tostring(i)..'Lowered="'..tostring(self.liftableAxes[i].isLowered)..'" axis'..tostring(i)..'Time="'..tostring(self:getRealAnimationTime(self.liftableAxes[i].animationName))..'"' end return attributes, nil end return nil end function liftableAxes:delete() if table.getn(self.liftableAxes) > 0 then for i=1, table.getn(self.liftableAxes) do if self.liftableAxes[i].airSound ~= nil then SoundUtil.deleteSample(self.liftableAxes[i].airSound) end end end end function liftableAxes:mouseEvent(posX, posY, isDown, isUp, button) end function liftableAxes:keyEvent(unicode, sym, modifier, isDown) end function liftableAxes:readUpdateStream(streamId, timestamp, connection) if connection.isServer then if table.getn(self.liftableAxes) > 0 then for i=1, table.getn(self.liftableAxes) do local playing = streamReadBool(streamId) if not playing then local received = streamReadBool(streamId) if not received then local animTime = Utils.getNoNil(streamReadFloat32(streamId),self:getRealAnimationTime(self.liftableAxes[i].animationName)) self:setRealAnimationTime(self.liftableAxes[i].animationName,animTime) end end end end end end function liftableAxes:writeUpdateStream(streamId, connection, dirtyMask) if not connection.isServer then if table.getn(self.liftableAxes) > 0 then for i=1, table.getn(self.liftableAxes) do local playing = self:getIsAnimationPlaying(self.liftableAxes[i].animationName) streamWriteBool(streamId, playing) if not playing then local sended = self.liftableAxes[i].animTimeSend streamWriteBool(streamId, sended) if not sended then self.liftableAxes[i].animTimeSend = true streamWriteFloat32(streamId, self:getRealAnimationTime(self.liftableAxes[i].animationName)) end end end end end end function liftableAxes:readStream(streamId, connection) if connection:getIsServer() then if table.getn(self.liftableAxes) > 0 then for i=1, table.getn(self.liftableAxes) do local isLowered = streamReadBool(streamId) self:setLiftableAxesState(i, isLowered, true) local animTime = Utils.getNoNil(streamReadFloat32(streamId),self:getRealAnimationTime(self.liftableAxes[i].animationName)) self:setRealAnimationTime(self.liftableAxes[i].animationName,animTime) end end end end function liftableAxes:writeStream(streamId, connection) if not connection:getIsServer() then if table.getn(self.liftableAxes) > 0 then for i=1, table.getn(self.liftableAxes) do streamWriteBool(streamId, self.liftableAxes[i].isLowered) streamWriteFloat32(streamId, self:getRealAnimationTime(self.liftableAxes[i].animationName)) end end end end function liftableAxes:update(dt) local canUsedMain = true if not self.useOffline and not liftableAxes:getMotorizedAttacher(self) then canUsedMain = false end if table.getn(self.liftableAxes) > 0 then for i=1, table.getn(self.liftableAxes) do local canUsed = canUsedMain if self.liftableAxes[i].referenceAxis ~= nil and self.liftableAxes[self.liftableAxes[i].referenceAxis].isLowered == false then canUsed = false end if canUsed or self.liftableAxes[i].mustInit then if self:getIsToggleLiftableAxisAllowed(i) then local outdoor = false if self.isClient and self.liftableAxes[i].outdoor and g_currentMission.player ~= nil and g_currentMission.player.rootNode ~= nil and g_currentMission.player.isEntered and g_currentMission.player.isControlled then local px, py, pz = getWorldTranslation(self.liftableAxes[i].outdoorIndex) local vx, vy, vz = getWorldTranslation(g_currentMission.player.rootNode) local distance = Utils.vector3Length(px-vx, py-vy, pz-vz) if distance <= 1.5 then outdoor = true if (not self.liftableAxes[i].noText) then if self.liftableAxes[i].isLowered == true then g_currentMission:addHelpButtonText(g_i18n:getText(self.liftableAxes[i].liftText), self.liftableAxes[i].liftKey, nil, GS_PRIO_NORMAL) else          g_currentMission:addHelpButtonText(g_i18n:getText(self.liftableAxes[i].lowerText), self.liftableAxes[i].liftKey, nil, GS_PRIO_NORMAL) end end end end if (self:getIsActiveForInput() and self.liftableAxes[i].indoor) or outdoor then if InputBinding.hasEvent(self.liftableAxes[i].liftKey) then self:setLiftableAxesState(i, not self.liftableAxes[i].isLowered) end end else      if (not self.liftableAxes[i].isLowered) then self:setLiftableAxesState(i, true) elseif self.liftableAxes[i].isLowered and self.liftableAxes[i].mustInit then self:setLiftableAxesState(i, true) end end local aTime = self:getAnimationTime(self.liftableAxes[i].animationName) if self:getIsAnimationPlaying(self.liftableAxes[i].animationName) then if not self.liftableAxes[i].mustInit then if self:getIsActiveForSound() then SoundUtil.playSample(self.liftableAxes[i].airSound, 0, 0, nil) SoundUtil.stop3DSample(self.liftableAxes[i].airSound) else        SoundUtil.play3DSample(self.liftableAxes[i].airSound) end if self.handBrakePressure ~= nil then if self.liftableAxes[i].isLowered then if self.handBrakePressure < (self.liftableAxes[i].airConsumption / 2) then self:stopAnimation(self.liftableAxes[i].animationName) if self.liftableAxes[i].outdoor and self.liftableAxes[i].outdoorAnimation ~= nil then self:stopAnimation(self.liftableAxes[i].outdoorAnimation) end else          self.handBrakePressure = self.handBrakePressure - (self.liftableAxes[i].airConsumption * dt) end end end end local numToGround = 0 local numToGroundRef = 0 for x=1, table.getn(self.liftableAxes[i].wheels) do if self.liftableAxes[i].hasSteerableWheel then self.wheels[self.liftableAxes[i].wheels[x].index].steeringAxleScale = self.liftableAxes[i].wheels[x].backupScale * aTime end if self.wheels[self.liftableAxes[i].wheels[x].index].hasGroundContact then numToGround = numToGround + 1 end end if self.liftableAxes[i].hasAutoCorrection then if self.liftableAxes[i].isLowered then for x=1, table.getn(self.liftableAxes[i].refWheels) do if self.wheels[self.liftableAxes[i].refWheels[x].index].hasGroundContact then numToGroundRef = numToGroundRef + 1 end end if numToGround == table.getn(self.liftableAxes[i].wheels) then self.liftableAxes[i].numTouched = self.liftableAxes[i].numTouched + 1 if self.liftableAxes[i].numTouched >= self.liftableAxes[i].touchValue then self:stopAnimation(self.liftableAxes[i].animationName) end elseif numToGround < table.getn(self.liftableAxes[i].wheels) and numToGroundRef >= table.getn(self.liftableAxes[i].refWheels) then self:playAnimation(self.liftableAxes[i].animationName, 1, self:getAnimationTime(self.liftableAxes[i].animationName), true) self.liftableAxes[i].animTimeSend = false end end end if self.liftableAxes[i].numTouched > 0 and not self.liftableAxes[i].isLowered then self.liftableAxes[i].numTouched = 0 end else      SoundUtil.stopSample(self.liftableAxes[i].airSound,true) SoundUtil.stop3DSample(self.liftableAxes[i].airSound) if (self.liftableAxes[i].mustInit and self.liftableAxes[i].hasSteerableWheel) or (self.liftableAxes[i].isLowered and self.liftableAxes[i].hasAutoCorrection) then local numToGround = 0 local numToGroundRef = 0 for x=1, table.getn(self.liftableAxes[i].wheels) do if self.liftableAxes[i].mustInit and self.liftableAxes[i].hasSteerableWheel then self.wheels[self.liftableAxes[i].wheels[x].index].steeringAxleScale = self.liftableAxes[i].wheels[x].backupScale * aTime end if self.liftableAxes[i].isLowered and self.liftableAxes[i].hasAutoCorrection then if self.wheels[self.liftableAxes[i].wheels[x].index].hasGroundContact then numToGround = numToGround + 1 end end end if self.liftableAxes[i].isLowered and self.liftableAxes[i].hasAutoCorrection then for x=1, table.getn(self.liftableAxes[i].refWheels) do if self.wheels[self.liftableAxes[i].refWheels[x].index].hasGroundContact then numToGroundRef = numToGroundRef + 1 end end if numToGround < table.getn(self.liftableAxes[i].wheels) and numToGroundRef >= table.getn(self.liftableAxes[i].refWheels) then self:playAnimation(self.liftableAxes[i].animationName, 1, self:getAnimationTime(self.liftableAxes[i].animationName), true) self.liftableAxes[i].animTimeSend = false elseif numToGroundRef < table.getn(self.liftableAxes[i].refWheels) and numToGround >= table.getn(self.liftableAxes[i].wheels) then self:playAnimation(self.liftableAxes[i].animationName, -1, self:getAnimationTime(self.liftableAxes[i].animationName), true) self.liftableAxes[i].animTimeSend = false end end end self.liftableAxes[i].mustInit = false end elseif self:getIsAnimationPlaying(self.liftableAxes[i].animationName) and self.liftableAxes[i].isLowered and self.liftableAxes[i].hasSteerableWheel then local aTime = self:getAnimationTime(self.liftableAxes[i].animationName) for x=1, table.getn(self.liftableAxes[i].wheels) do self.wheels[self.liftableAxes[i].wheels[x].index].steeringAxleScale = self.liftableAxes[i].wheels[x].backupScale * aTime end end end end end function liftableAxes:draw() if self.isClient and self:getIsActiveForInput(true) then local canUsed = true if not self.useOffline and not liftableAxes:getMotorizedAttacher(self) then canUsed = false end if table.getn(self.liftableAxes) > 0 and canUsed then for i=1, table.getn(self.liftableAxes) do if self.liftableAxes[i].referenceAxis == nil or (self.liftableAxes[i].referenceAxis ~= nil and self.liftableAxes[self.liftableAxes[i].referenceAxis].isLowered ~= false) then if self:getIsToggleLiftableAxisAllowed(i) and self.liftableAxes[i].indoor and (not self.liftableAxes[i].noText) then if self.liftableAxes[i].isLowered == true then g_currentMission:addHelpButtonText(g_i18n:getText(self.liftableAxes[i].liftText), self.liftableAxes[i].liftKey, nil, GS_PRIO_NORMAL) else        g_currentMission:addHelpButtonText(g_i18n:getText(self.liftableAxes[i].lowerText), self.liftableAxes[i].liftKey, nil, GS_PRIO_NORMAL) end end end end end end end function liftableAxes:getIsToggleLiftableAxisAllowed(liftAxis) if self.liftableAxes[liftAxis] ~= nil and self.getCapacity ~= nil and self.getFreeCapacity ~= nil then local level = (self:getCapacity() - self:getFreeCapacity()) / self:getCapacity() if level > self.liftableAxes[liftAxis].maxLoadForLift then return false end end return true end function liftableAxes:setLiftableAxesState(liftAxis, isLowered, noEventSend) if self.liftableAxes[liftAxis] ~= nil then if self.handBrakePressure ~= nil and not self.liftableAxes[liftAxis].mustInit then if isLowered and self.handBrakePressure < (self.liftableAxes[liftAxis].airConsumption / 2) then isLowered = false end end if self.liftableAxes[liftAxis].isLowered ~= isLowered then if self.liftableAxes[liftAxis].referenceAxis ~= nil and self.liftableAxes[self.liftableAxes[liftAxis].referenceAxis].isLowered == false then isLowered = false end liftableAxesStateEvent.sendEvent(self, liftAxis, isLowered, noEventSend) self.liftableAxes[liftAxis].isLowered = isLowered if isLowered then self:playAnimation(self.liftableAxes[liftAxis].animationName, 1, self:getAnimationTime(self.liftableAxes[liftAxis].animationName), true) self.liftableAxes[liftAxis].animTimeSend = false if self.liftableAxes[liftAxis].outdoor and self.liftableAxes[liftAxis].outdoorAnimation ~= nil then self:playAnimation(self.liftableAxes[liftAxis].outdoorAnimation, 1, self:getAnimationTime(self.liftableAxes[liftAxis].outdoorAnimation), true) end else     if table.getn(self.liftableAxes) > 0 then for i=1, table.getn(self.liftableAxes) do if i ~= liftAxis then if self.liftableAxes[i].referenceAxis ~= nil and self.liftableAxes[i].referenceAxis == liftAxis and self.liftableAxes[i].isLowered then self:setLiftableAxesState(i, false) end end end end self:playAnimation(self.liftableAxes[liftAxis].animationName, -1, self:getAnimationTime(self.liftableAxes[liftAxis].animationName), true) self.liftableAxes[liftAxis].animTimeSend = false if self.liftableAxes[liftAxis].outdoor and self.liftableAxes[liftAxis].outdoorAnimation ~= nil then self:playAnimation(self.liftableAxes[liftAxis].outdoorAnimation, -1, self:getAnimationTime(self.liftableAxes[liftAxis].outdoorAnimation), true) end end end end end
liftableAxesStateEvent = {} liftableAxesStateEvent_mt = Class(liftableAxesStateEvent, Event) InitEventClass(liftableAxesStateEvent, "liftableAxesStateEvent") function liftableAxesStateEvent:emptyNew() local self = Event:new(liftableAxesStateEvent_mt) return self end function liftableAxesStateEvent:new(object, liftAxis, isLowered) local self = liftableAxesStateEvent:emptyNew() self.object = object self.liftAxis = liftAxis self.isLowered = isLowered return self end function liftableAxesStateEvent:readStream(streamId, connection) self.object = readNetworkNodeObject(streamId) self.liftAxis = streamReadInt8(streamId) self.isLowered = streamReadBool(streamId) self:run(connection) end function liftableAxesStateEvent:writeStream(streamId, connection) writeNetworkNodeObject(streamId, self.object) streamWriteInt8(streamId, self.liftAxis) streamWriteBool(streamId, self.isLowered) end function liftableAxesStateEvent:run(connection) if not connection:getIsServer() then g_server:broadcastEvent(liftableAxesStateEvent:new(self.object, self.liftAxis, self.isLowered), nil, nil, self.object) end if self.object ~= nil then self.object:setLiftableAxesState(self.liftAxis, self.isLowered, true) end end function liftableAxesStateEvent.sendEvent(vehicle, liftAxis, isLowered, noEventSend) if noEventSend == nil or noEventSend == false then if g_server ~= nil then g_server:broadcastEvent(liftableAxesStateEvent:new(vehicle, liftAxis, isLowered), nil, nil, vehicle) else    g_client:getServerConnection():sendEvent(liftableAxesStateEvent:new(vehicle, liftAxis, isLowered)) end end end
